﻿USE AdventureWorks2008
GO
-- Lock a row by starting (but not yet finishing) a transaction
BEGIN TRANSACTION

	UPDATE Person.Person
	   SET Title = NULL 
	 WHERE BusinessEntityID = 1
 
ROLLBACK TRANSACTION

--
-- Generated Queries
--

-- Query returning a full entity:
SELECT [Extent1].[BusinessEntityID] AS [BusinessEntityID], 
	   [Extent1].[PersonType] AS [PersonType], 
	   [Extent1].[NameStyle] AS [NameStyle], 
	   [Extent1].[Title] AS [Title], 
	   [Extent1].[FirstName] AS [FirstName], 
	   [Extent1].[MiddleName] AS [MiddleName], 
	   [Extent1].[LastName] AS [LastName], 
	   [Extent1].[Suffix] AS [Suffix], 
	   [Extent1].[EmailPromotion] AS [EmailPromotion], 
	   [Extent1].[AdditionalContactInfo] AS [AdditionalContactInfo], 
	   [Extent1].[Demographics] AS [Demographics], 
	   [Extent1].[rowguid] AS [rowguid], 
	   [Extent1].[ModifiedDate] AS [ModifiedDate] 
  FROM [Person].[Person] AS [Extent1]
GO

-- Query returning data transfer object:
SELECT 1 AS [C1], 
	   [Extent1].[LastName] AS [LastName], 
       [Extent1].[FirstName] AS [FirstName]
  FROM [Person].[Person] AS [Extent1]
GO

USE [AdventureWorks2008]
GO

-- EF 4.0 Include:
 SELECT [Project1].[BusinessEntityID] AS [BusinessEntityID], 
		[Project1].[PersonType] AS [PersonType], 
		[Project1].[NameStyle] AS [NameStyle], 
		[Project1].[Title] AS [Title], 
		[Project1].[FirstName] AS [FirstName], 
		[Project1].[MiddleName] AS [MiddleName], 
		[Project1].[LastName] AS [LastName], 
		[Project1].[Suffix] AS [Suffix], 
		[Project1].[EmailPromotion] AS [EmailPromotion], 
		[Project1].[AdditionalContactInfo] AS [AdditionalContactInfo], 
		[Project1].[Demographics] AS [Demographics], 
		[Project1].[rowguid] AS [rowguid], 
		[Project1].[ModifiedDate] AS [ModifiedDate], 
		[Project1].[C1] AS [C1], 
		[Project1].[BusinessEntityID1] AS [BusinessEntityID1], 
		[Project1].[PhoneNumber] AS [PhoneNumber], 
		[Project1].[PhoneNumberTypeID] AS [PhoneNumberTypeID], 
		[Project1].[ModifiedDate1] AS [ModifiedDate1]
   FROM (SELECT [Extent1].[BusinessEntityID] AS [BusinessEntityID], 
				[Extent1].[PersonType] AS [PersonType], 
				[Extent1].[NameStyle] AS [NameStyle], 
				[Extent1].[Title] AS [Title], 
				[Extent1].[FirstName] AS [FirstName], 
				[Extent1].[MiddleName] AS [MiddleName], 
				[Extent1].[LastName] AS [LastName], 
				[Extent1].[Suffix] AS [Suffix], 
				[Extent1].[EmailPromotion] AS [EmailPromotion], 
				[Extent1].[AdditionalContactInfo] AS [AdditionalContactInfo], 
				[Extent1].[Demographics] AS [Demographics], 
				[Extent1].[rowguid] AS [rowguid], 
				[Extent1].[ModifiedDate] AS [ModifiedDate], 
				[Extent2].[BusinessEntityID] AS [BusinessEntityID1], 
				[Extent2].[PhoneNumber] AS [PhoneNumber], 
				[Extent2].[PhoneNumberTypeID] AS [PhoneNumberTypeID], 
				[Extent2].[ModifiedDate] AS [ModifiedDate1], 
				CASE WHEN ([Extent2].[BusinessEntityID] IS NULL) THEN CAST(NULL AS int) ELSE 1 END AS [C1]
	       FROM [Person].[Person] AS [Extent1]
	     LEFT OUTER JOIN [Person].[PersonPhone] AS [Extent2] 
		     ON [Extent1].[BusinessEntityID] = [Extent2].[BusinessEntityID]
        )  AS [Project1]
ORDER BY [Project1].[BusinessEntityID] ASC, [Project1].[C1] ASC
GO

-- EF 4.0 Outer Join:
  SELECT [Project1].[BusinessEntityID] AS [BusinessEntityID], 
	   [Project1].[LastName] AS [LastName], 
	   [Project1].[C1] AS [C1], 
	   [Project1].[BusinessEntityID1] AS [BusinessEntityID1], 
	   [Project1].[PhoneNumber] AS [PhoneNumber], 
	   [Project1].[PhoneNumberTypeID] AS [PhoneNumberTypeID], 
	   [Project1].[ModifiedDate] AS [ModifiedDate]
  FROM (SELECT [Extent1].[BusinessEntityID] AS [BusinessEntityID], 
			   [Extent1].[LastName] AS [LastName], 
			   [Extent2].[BusinessEntityID] AS [BusinessEntityID1], 
			   [Extent2].[PhoneNumber] AS [PhoneNumber], 
			   [Extent2].[PhoneNumberTypeID] AS [PhoneNumberTypeID], 
			   [Extent2].[ModifiedDate] AS [ModifiedDate], 
			   CASE 
			      WHEN ([Extent2].[BusinessEntityID] IS NULL) THEN CAST(NULL AS int) 
				  ELSE 1 
			   END AS [C1]
	FROM  [Person].[Person] AS [Extent1]
	LEFT OUTER JOIN [Person].[PersonPhone] AS [Extent2] ON [Extent1].[BusinessEntityID] = [Extent2].[BusinessEntityID]
)  AS [Project1]
ORDER BY [Project1].[BusinessEntityID] ASC, [Project1].[C1] ASC
GO

-- EF 4.0 Projection
SELECT 
[Project1].[BusinessEntityID] AS [BusinessEntityID], 
[Project1].[LastName] AS [LastName], 
[Project1].[PersonType] AS [PersonType], 
[Project1].[NameStyle] AS [NameStyle], 
[Project1].[Title] AS [Title], 
[Project1].[FirstName] AS [FirstName], 
[Project1].[MiddleName] AS [MiddleName], 
[Project1].[Suffix] AS [Suffix], 
[Project1].[EmailPromotion] AS [EmailPromotion], 
[Project1].[AdditionalContactInfo] AS [AdditionalContactInfo], 
[Project1].[Demographics] AS [Demographics], 
[Project1].[rowguid] AS [rowguid], 
[Project1].[ModifiedDate] AS [ModifiedDate], 
[Project1].[C1] AS [C1], 
[Project1].[BusinessEntityID1] AS [BusinessEntityID1], 
[Project1].[PhoneNumber] AS [PhoneNumber], 
[Project1].[PhoneNumberTypeID] AS [PhoneNumberTypeID], 
[Project1].[ModifiedDate1] AS [ModifiedDate1]
FROM ( SELECT 
	[Extent1].[BusinessEntityID] AS [BusinessEntityID], 
	[Extent1].[PersonType] AS [PersonType], 
	[Extent1].[NameStyle] AS [NameStyle], 
	[Extent1].[Title] AS [Title], 
	[Extent1].[FirstName] AS [FirstName], 
	[Extent1].[MiddleName] AS [MiddleName], 
	[Extent1].[LastName] AS [LastName], 
	[Extent1].[Suffix] AS [Suffix], 
	[Extent1].[EmailPromotion] AS [EmailPromotion], 
	[Extent1].[AdditionalContactInfo] AS [AdditionalContactInfo], 
	[Extent1].[Demographics] AS [Demographics], 
	[Extent1].[rowguid] AS [rowguid], 
	[Extent1].[ModifiedDate] AS [ModifiedDate], 
	[Extent2].[BusinessEntityID] AS [BusinessEntityID1], 
	[Extent2].[PhoneNumber] AS [PhoneNumber], 
	[Extent2].[PhoneNumberTypeID] AS [PhoneNumberTypeID], 
	[Extent2].[ModifiedDate] AS [ModifiedDate1], 
	CASE WHEN ([Extent2].[BusinessEntityID] IS NULL) THEN CAST(NULL AS int) ELSE 1 END AS [C1]
	FROM  [Person].[Person] AS [Extent1]
	LEFT OUTER JOIN [Person].[PersonPhone] AS [Extent2] ON [Extent1].[BusinessEntityID] = [Extent2].[BusinessEntityID]
)  AS [Project1]
ORDER BY [Project1].[BusinessEntityID] ASC, [Project1].[C1] ASC
GO

-- EF 4.0 Join with projection:
		 SELECT [Extent1].[BusinessEntityID] AS [BusinessEntityID], 
		 	    [Extent1].[LastName] AS [LastName], 
			    [Extent2].[PhoneNumber] AS [PhoneNumber]
           FROM [Person].[Person] AS [Extent1]
LEFT OUTER JOIN [Person].[PersonPhone] AS [Extent2] 
             ON [Extent1].[BusinessEntityID] = [Extent2].[BusinessEntityID]

-- Linq to SQL query:
SELECT [t0].[LastName], [t1].[BusinessEntityID], [t1].[PhoneNumber], [t1].[PhoneNumberTypeID], [t1].[ModifiedDate], (
    SELECT COUNT(*)
      FROM [Person].[PersonPhone] AS [t2]
     WHERE [t2].[BusinessEntityID] = [t0].[BusinessEntityID]
      ) AS [value]
    FROM [Person].[Person] AS [t0]
LEFT OUTER JOIN [Person].[PersonPhone] AS [t1] 
      ON [t1].[BusinessEntityID] = [t0].[BusinessEntityID]
ORDER BY [t0].[BusinessEntityID], [t1].[PhoneNumber], [t1].[PhoneNumberTypeID]
GO

-- Manual query (identical to L2S join with projection):
		 SELECT [t0].[LastName], [t1].[PhoneNumber]
		   FROM [Person].[Person] AS [t0]
LEFT OUTER JOIN [Person].[PersonPhone] AS [t1] 
			 ON [t1].[BusinessEntityID] = [t0].[BusinessEntityID]
GO